'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _routerReverseRouterJs = require('../router/ReverseRouter.js');var _routerReverseRouterJs2 = _interopRequireDefault(_routerReverseRouterJs);var _routerNodeFactoryJs = require(
'../router/NodeFactory.js');var _routerNodeFactoryJs2 = _interopRequireDefault(_routerNodeFactoryJs);var _routerDomainNodeJs = require(
'../router/DomainNode.js');var _routerDomainNodeJs2 = _interopRequireDefault(_routerDomainNodeJs);var _routerMethodNodeJs = require(
'../router/MethodNode.js');var _routerMethodNodeJs2 = _interopRequireDefault(_routerMethodNodeJs);var _routerPathNodeJs = require(
'../router/PathNode.js');var _routerPathNodeJs2 = _interopRequireDefault(_routerPathNodeJs);var _httpClientHttpRequestJs = require(
'../http/ClientHttpRequest.js');var _httpClientHttpRequestJs2 = _interopRequireDefault(_httpClientHttpRequestJs);var _httpClientCookieJarJs = require(
'../http/ClientCookieJar.js');var _httpClientCookieJarJs2 = _interopRequireDefault(_httpClientCookieJarJs);var _ProviderJs = require(
'../Provider.js');var _ProviderJs2 = _interopRequireDefault(_ProviderJs);

// The reason we use full path is to make webpack's resolve.alias work.
// We need to replace custom node registration with user file so that
// custom nodes can be loaded in both client and server side.
var _soyaLibServerRegisterRouterNodesJs = require('soya/lib/server/registerRouterNodes.js');var _soyaLibServerRegisterRouterNodesJs2 = _interopRequireDefault(_soyaLibServerRegisterRouterNodesJs);

/**
 * Responsible for client runtime.
 *
 * @CLIENT
 */var 
SoyaClient = (function () {













































  /**
   * @param {Object} clientConfig
   */
  function SoyaClient(clientConfig) {_classCallCheck(this, SoyaClient);
    this._clientConfig = clientConfig;
    this._cookieJar = new _httpClientCookieJarJs2['default']();
    var nodeFactory = new _routerNodeFactoryJs2['default']();
    nodeFactory.registerNodeType(_routerDomainNodeJs2['default']);
    nodeFactory.registerNodeType(_routerMethodNodeJs2['default']);
    nodeFactory.registerNodeType(_routerPathNodeJs2['default']);
    // TODO: Make sure swapping for custom nodes also work at client side.
    (0, _soyaLibServerRegisterRouterNodesJs2['default'])(nodeFactory);

    this._reverseRouter = new _routerReverseRouterJs2['default'](nodeFactory);
    this._provider = new _ProviderJs2['default'](clientConfig, this._reverseRouter, false);
    this._pages = {};
    this._storeCache = {};}


  /**
   * @param {{[key: string]: Array<Array<any>>}} routeConfigMap
   */_createClass(SoyaClient, [{ key: 'addRouteConfig', value: 
    function addRouteConfig(routeConfigMap) {
      if (!routeConfigMap) return;
      var routeId;
      for (routeId in routeConfigMap) {
        if (!routeConfigMap.hasOwnProperty(routeId)) continue;
        this._reverseRouter.reg(routeId, routeConfigMap[routeId]);}}



    /**
     * @param {Function} pageClass
     */ }, { key: 'register', value: 
    function register(pageClass) {
      // We do overrides just in case there are updates.
      // TODO: Figure out history API navigation.
      this._pages[pageClass.pageName] = pageClass;

      if (this._currentPageName == pageClass.pageName) {
        // If a registration is made for currently active page, it means we're
        // hot-reloading. TODO: Reconcile this with history API navigation later.
        this.refresh();}}



    /**
     * Re-run rendering for the current page.
     */ }, { key: 'refresh', value: 
    function refresh() {
      var pageClass = this._getPageClass(this._currentPageName);
      var pageArgs = this._currentPageArgs;
      if (!pageArgs) {
        throw new Error('Unable to refresh, current page arguments does not exist!');}

      this._dismantleCurrentPage();
      this._render(pageClass, pageArgs);}


    /**
     * @param {string} name
     * @param {Object} routeArgs
     * @param {?any} hydratedState
     */ }, { key: 'navigate', value: 
    function navigate(name, routeArgs, hydratedState) {
      this._currentPageName = name;
      this._currentPageArgs = null;

      var pageClass = this._getPageClass(name);
      var httpRequest = new _httpClientHttpRequestJs2['default']();
      var pageArgs = { 
        httpRequest: httpRequest, 
        routeArgs: routeArgs, 
        hydratedState: hydratedState };

      this._currentPageArgs = pageArgs;
      this._dismantleCurrentPage();
      this._render(pageClass, this._currentPageArgs);}


    /**
     * @param {Function} pageClass
     * @param {Object} pageArgs
     */ }, { key: '_render', value: 
    function _render(pageClass, pageArgs) {
      // Create new page instance - dependencies should be fetched and cached
      // by Provider.
      var page = new pageClass(this._provider, this._cookieJar, false);
      var storeNamespace = this._getPageStoreNamespace(pageClass);

      var store = this._storeCache[storeNamespace];
      if (!store) {
        store = page.createStore(pageArgs.hydratedState);}

      var hasStore = !!store;

      if (hasStore) {
        this._storeCache[storeNamespace] = store;
        if (module.hot) {
          store._mayHotReloadSegments();}}



      page.render(pageArgs.httpRequest, pageArgs.routeArgs, 
      store, this._renderCallback.bind(this, store));}


    /**
     * Extract state from the currently active store.
     *
     * @return {any}
     */ }, { key: '_extractState', value: 
    function _extractState() {
      var store = this._getCurrentStore();
      return store._getState();}


    /**
     * @param {any} newState
     */ }, { key: '_replaceState', value: 
    function _replaceState(newState) {
      var store = this._getCurrentStore();
      store._replaceState(newState);}


    /**
     * @param {void | Store} store
     * @param {RenderResult} renderResult
     */ }, { key: '_renderCallback', value: 
    function _renderCallback(store, renderResult) {
      // Start rendering, this also do Segment registrations.
      window.renderResult = renderResult;
      if (store) store._startRender();
      this._currentPageDismantle = renderResult.contentRenderer.render();
      if (store) store._endRender();}


    /**
     * @param {string} name
     */ }, { key: '_getPageClass', value: 
    function _getPageClass(name) {
      var pageClass = this._pages[name];
      if (!pageClass) {
        throw new Error('Call to non-existent or non-loaded page: ' + name);}

      return pageClass;}


    /**
     * @param {Page} pageClass
     * @return {string}
     */ }, { key: '_getPageStoreNamespace', value: 
    function _getPageStoreNamespace(pageClass) {
      var storeNamespace = '__default';
      if (typeof pageClass.getStoreNamespace == 'function') {
        storeNamespace = pageClass.getStoreNamespace();}

      return storeNamespace;}


    /**
     * @returns {Store}
     */ }, { key: '_getCurrentStore', value: 
    function _getCurrentStore() {
      var pageClass = this._getPageClass(this._currentPageName);
      var storeNamespace = this._getPageStoreNamespace(pageClass);
      return this._storeCache[storeNamespace];} }, { key: '_dismantleCurrentPage', value: 


    function _dismantleCurrentPage() {
      if (this._currentPageDismantle) this._currentPageDismantle();} }]);return SoyaClient;})();exports['default'] = SoyaClient;module.exports = exports['default']; /**
                                                                                                                                                                      * @type {{[key: string]: Page}}
                                                                                                                                                                      */ /**
                                                                                                                                                                          * @type {void | string}
                                                                                                                                                                          */ /**
                                                                                                                                                                              * @type {void | {httpRequest: ClientHttpRequest; routeArgs: Object; hydratedState: Object}}
                                                                                                                                                                              */ /**
                                                                                                                                                                                  * @type {Function}
                                                                                                                                                                                  */ /**
                                                                                                                                                                                      * @type {Object}
                                                                                                                                                                                      */ /**
                                                                                                                                                                                          * @type {ReverseRouter}
                                                                                                                                                                                          */ /**
                                                                                                                                                                                              * @type {Provider}
                                                                                                                                                                                              */ /**
                                                                                                                                                                                                  * @type {{[key: string]: Store}}
                                                                                                                                                                                                  */ /**
                                                                                                                                                                                                      * @type {ClientCookieJar}
                                                                                                                                                                                                      */
//# sourceMappingURL=SoyaClient.js.map