'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;desc = parent = undefined;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _AssetServer2 = require('../AssetServer');var _AssetServer3 = _interopRequireDefault(_AssetServer2);var _httpServerHttpRequestJs = require(
'../../http/ServerHttpRequest.js');var _httpServerHttpRequestJs2 = _interopRequireDefault(_httpServerHttpRequestJs);

var fs = require('fs');
var path = require('path');
var mime = require('mime');

/**
 * Reads asset from the webpack output directory.
 *
 * TODO: Implement memory caching.
 *
 * @SERVER
 */var 
WebpackAssetServer = (function (_AssetServer) {_inherits(WebpackAssetServer, _AssetServer);















  /**
   * @param {string} assetHostPath
   * @param {string} absoluteTempDir
   * @param {Logger} logger
   */
  function WebpackAssetServer(assetHostPath, absoluteTempDir, logger) {_classCallCheck(this, WebpackAssetServer);
    _get(Object.getPrototypeOf(WebpackAssetServer.prototype), 'constructor', this).call(this, assetHostPath);
    this._assetHostPath = assetHostPath;
    this._absoluteTempDir = absoluteTempDir;
    this._logger = logger;}


  /**
   * @param {string} assetPath
   * @returns {{size: number; content: any}}
   */_createClass(WebpackAssetServer, [{ key: 'get', value: 
    function get(assetPath) {
      var fullPath = path.join(this._absoluteTempDir, assetPath), stat;
      try {
        // TODO: We might have to switch to async for better performance here.
        stat = fs.statSync(fullPath);
        return { 
          size: stat.size, 
          content: fs.readFileSync(fullPath) };} 

      catch (err) {
        this._logger.notice('Asset server failed to retrieve: \'' + fullPath + '\'.', err);
        return null;}}



    /**
     * @param {http.incomingMessage} request
     * @param {httpServerResponse} response
     * @returns {boolean}
     */ }, { key: 'handle', value: 
    function handle(request, response) {
      var httpRequest = new _httpServerHttpRequestJs2['default'](request);
      if (httpRequest.startsWith(this._assetHostPath)) {
        var fullRequestPath = path.join(httpRequest.getHost(), decodeURI(httpRequest.getPath()));
        var realPath = fullRequestPath.substr(this._assetHostPath.length);
        var asset = this.get(realPath);
        if (asset == null || asset.content == null) {
          return false;}

        // TODO: Handle e-tag, etc.
        response.writeHead(200, { 
          'Content-Type': mime.lookup(realPath), 
          'Content-Length': asset.size });

        response.end(asset.content);
        return true;}

      return false;} }]);return WebpackAssetServer;})(_AssetServer3['default']);exports['default'] = WebpackAssetServer;module.exports = exports['default']; /**
                                                                                                                                                              * @type {string}
                                                                                                                                                              */ /**
                                                                                                                                                                  * @type {string}
                                                                                                                                                                  */ /**
                                                                                                                                                                      * @type {Logger}
                                                                                                                                                                      */
//# sourceMappingURL=WebpackAssetServer.js.map